### Method

# FwupdPlugin Plugin runner_write_firmware

since: 2.0.7

#### Declaration [src]

    gboolean
    fu_plugin_runner_write_firmware (
      FuPlugin* self,
      FuDevice* device,
      FuFirmware* firmware,
      FuProgress* progress,
      FwupdInstallFlags flags,
      GError** error
    )

#### Description [src]

Call into the plugin’s write firmware routine.

Available since: 2.0.7

#### Parameters

`device`

  Type: `FuDevice`

  A device.

  The data is owned by the caller of the method.

`firmware`

  Type: `FuFirmware`

  A `FuFirmware`.

  The data is owned by the caller of the method.

`progress`

  Type: `FuProgress`

  A `FuProgress`.

  The data is owned by the caller of the method.

`flags`

  Type: `FwupdInstallFlags`

  Install flags.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` for success, `FALSE` for failure.